#include "../inc/color.h"
#include "../inc/pwm.h"
#include <avr/pgmspace.h>
#include <stdint.h>

color_rgb_t colors[COLOR_LED_COUNT];
//Base = 1.1
//Resolution = 128
//Range = 1000K - 2300K
color_rgb_t temp_table[] PROGMEM = {
	{255,  51,   0},
	{255,  51,   0},
	{255,  52,   0},
	{255,  54,   0},
	{255,  56,   0},
	{255,  58,   0},
	{255,  60,   0},
	{255,  61,   0},
	{255,  63,   0},
	{255,  65,   0},
	{255,  67,   0},
	{255,  69,   0},
	{255,  70,   0},
	{255,  71,   0},
	{255,  72,   0},
	{255,  74,   0},
	{255,  75,   0},
	{255,  76,   0},
	{255,  78,   0},
	{255,  79,   0},
	{255,  80,   0},
	{255,  82,   0},
	{255,  83,   0},
	{255,  84,   0},
	{255,  85,   0},
	{255,  86,   0},
	{255,  87,   0},
	{255,  88,   0},
	{255,  89,   0},
	{255,  90,   0},
	{255,  91,   0},
	{255,  93,   0},
	{255,  93,   0},
	{255,  94,   0},
	{255,  95,   0},
	{255,  96,   0},
	{255,  97,   0},
	{255,  98,   0},
	{255,  99,   0},
	{255, 100,   0},
	{255, 101,   0},
	{255, 102,   0},
	{255, 102,   0},
	{255, 103,   0},
	{255, 104,   0},
	{255, 105,   0},
	{255, 106,   0},
	{255, 107,   0},
	{255, 108,   0},
	{255, 109,   0},
	{255, 110,   0},
	{255, 111,   0},
	{255, 111,   0},
	{255, 112,   0},
	{255, 113,   0},
	{255, 113,   0},
	{255, 114,   0},
	{255, 115,   0},
	{255, 115,   0},
	{255, 116,   0},
	{255, 117,   0},
	{255, 118,   0},
	{255, 118,   0},
	{255, 119,   0},
	{255, 119,   0},
	{255, 120,   0},
	{255, 121,   0},
	{255, 122,   0},
	{255, 122,   0},
	{255, 123,   0},
	{255, 124,   0},
	{255, 124,   0},
	{255, 125,   0},
	{255, 125,   0},
	{255, 126,   0},
	{255, 127,   0},
	{255, 127,   0},
	{255, 128,   0},
	{255, 128,   0},
	{255, 129,   0},
	{255, 130,   0},
	{255, 130,   0},
	{255, 131,   0},
	{255, 131,   0},
	{255, 132,   0},
	{255, 132,   0},
	{255, 133,   0},
	{255, 133,   0},
	{255, 134,   0},
	{255, 134,   0},
	{255, 135,   0},
	{255, 135,   1},
	{255, 136,   2},
	{255, 136,   3},
	{255, 137,   4},
	{255, 138,   6},
	{255, 139,   7},
	{255, 139,   8},
	{255, 140,   9},
	{255, 141,  11},
	{255, 141,  12},
	{255, 142,  14},
	{255, 142,  16},
	{255, 143,  18},
	{255, 143,  20},
	{255, 144,  21},
	{255, 144,  23},
	{255, 145,  25},
	{255, 145,  27},
	{255, 146,  29},
	{255, 146,  30},
	{255, 147,  31},
	{255, 147,  32},
	{255, 148,  33},
	{255, 149,  36},
	{255, 150,  37},
	{255, 150,  38},
	{255, 151,  39},
	{255, 152,  41},
	{255, 152,  42},
	{255, 153,  43},
	{255, 153,  44},
	{255, 154,  45},
	{255, 154,  46},
	{255, 155,  47},
	{255, 155,  48},
	{255, 156,  49},
	{255, 156,  50},
};

/*
void hsv_to_rgb(const color_hsv_t *in, color_rgb_t *out) {
	uint8_t r, g, b, i, f;
	uint16_t p, q, t;

	if(in->s == 0) {
		r = g = b = in->v;
	} else {
		i = in->h / 43;
		f = in->h % 43;
		p = (in->v * (255 - in->s)) / 256;
		q = (in->v * ((10710 - (in->s * f)) / 42)) / 256;
		t = (in->v * ((10710 - (in->s * (42 - f))) / 42)) / 256;

		switch(i) {
		case 0:
			r = in->v; g = t; b = p;
			break;
		case 1:
			r = q; g = in->v; b = p;
			break;
		case 2:
			r = p; g = in->v; b = t;
			break;
		case 3:
			r = p; g = q; b = in->v;
			break;
		case 4:
			r = t; g = p; b = in->v;
			break;
		default:
			r = in->v; g = p; b = q;
			break;
		}
	}

	out->r = r;
	out->g = g;
	out->b = b;
}
*/

void temp_to_rgb(uint8_t temperature, uint8_t intensity, color_rgb_t *rgb_out) {
	uint16_t r, g, b;
	r = pgm_read_byte(&temp_table[temperature / 2].r) * intensity;
	g = pgm_read_byte(&temp_table[temperature / 2].g) * intensity;
	b = pgm_read_byte(&temp_table[temperature / 2].b) * intensity;
	rgb_out->r = r / 256;
	rgb_out->g = g / 256;
	rgb_out->b = b / 256;
}

void color_tick(color_ti_t data[COLOR_LED_COUNT]) {
	static color_rgb_t rgb[COLOR_LED_COUNT];
	for (uint8_t i = 0; i < COLOR_LED_COUNT; ++i) {
		temp_to_rgb(data[i].temperature, data[i].intensity, &rgb[i]);
	}
	pwm_update((uint8_t *)&rgb);
}
