#include "../inc/main.h"
#include "../inc/init.h"
#include "../inc/pwm.h"
#include "../inc/fire.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>
#include <avr/eeprom.h>
#include <util/delay.h>
#include <stdlib.h>

uint16_t rand_seed EEMEM = 0xffff;

int main(void) {
	init_ports();
	pwm_init();

	wdt_enable(WDTO_1S);

	sei();

	uint16_t s = eeprom_read_word(&rand_seed);
	srand(++s);
	eeprom_write_word(&rand_seed, s);

	PWR_ON();

	uint8_t button = 0;

	fire_add_wood();
	fire_ignite();

	for (;;) {
		wdt_reset();
		if (!fire_tick()) {
			pwm_update(0);
			for (;;) {
				wdt_reset();
				PWR_OFF();
			}
		}

		if (!(RPI_SW & _BV(PIN_SW))) {
			if (button < 0xff) ++button;
		} else {
			if (button > 200) {
				fire_add_oil();
			} else if (button > 20) {
				fire_add_wood();
			}
			button = 0;
		}
		_delay_ms(5);
	}
}
